#include <stdio.h>
#include <math.h>
#include <avs/flow.h>
#include <avs/avs_data.h>
#include <avs/field.h>

interface()
{
	int out_port;		/* temporary to hold the port number */
	int parm;		/* temporary to hold the parm number */

	/* Set the module name and type */
	AVSset_module_name("Input_interface_IBM", MODULE_DATA);

	/* There are no input ports for this module */

        /* Create output ports for the result */
        out_port = AVScreate_output_port("Field Output", "field 1D scalar uniform float");
	

	/* Add parameter:  */
	parm = AVSadd_parameter("M.F.N.(Slot 1)","integer",10, 1, 10); 
	parm = AVSadd_parameter("M.F.N.(Slot 2)","integer",10, 1, 10); 
	parm = AVSadd_float_parameter("Slots Width", 0.5, 0.1, 10.0);
	parm = AVSadd_parameter("P.F.N.(Slot 1)","integer",128, 1, 256); 
	parm = AVSadd_parameter("P.F.N.(Slot 2)","integer",128, 1, 256); 
	parm = AVSadd_float_parameter("Angle", 0.6, 0.0, 1.57);
	parm = AVSadd_float_parameter("Slots Distance", 0.1, 0.1, 10.0);
	parm = AVSadd_parameter("Do it!", "boolean", 1, 0, 1);
        parm = AVSadd_parameter("abort", "oneshot", 0, 0, 1);

	/* There is no compute function for this module */
}

#define Stockdata 7
#define COMMAND(a) sprintf(inbuf, a); \
  result=AVScommand("kernel", inbuf, &outbuf, &errbuf); \
  if (!result) {AVSerror(errbuf); return(0);}

main(argc,argv)
int	argc;
char	*argv[];
{
  
  int abort,sleep = 1;
  int i,j,m,n;
  float  *ha, *fai, *hd;
  AVSfield_float *output, *input;  
  int dims[1];

  char *outbuf, *errbuf, inbuf[1024];
  int result;

  /* coroutine initilization */
  AVScorout_init(argc,argv,interface);
  AVScorout_set_sync(0);
  
  /* Allocate space for stock data */
  dims[0] = Stockdata;
  input = (AVSfield_float *)AVSdata_alloc
    ("field 1D scalar uniform float",dims);
  
  while (1) {
    
    do {
      AVScorout_wait();
      AVScorout_input(&i,&j,&ha,&m,&n,&fai,&hd,&sleep,&abort);
      if (abort) {
	 COMMAND("quit -dialog");
/*	 COMMAND("net_clear");
	 exit(0); */
       }
    } while (sleep);
    input->data[0] = i; input->data[1] = j;
    input->data[2] = *ha;
    input->data[3] = m; input->data[4] = n;
    input->data[5] = *fai; input->data[6] = *hd;
    
    output = input;
    
    AVScorout_exec(); /* syncronization */
    AVScorout_output(output);
    fprintf(stderr, "Interface  Done \n");
    AVSmodify_parameter("Do it!",AVS_VALUE, 1, 0, 1);
    sleep = 1;
    
  }
  fprintf(stderr, "\n!!!!!!!! Done !!!!!!!!\n");
  /*   AVSfield_free(input); */
  
}
